describe("FileUploadController", function () {
  var fileUploadController;
	var $scope;
	var $rootScope;
	var container;
	var widget;
	
	var baseContainer = ZhHelper.baseContainerWithTwoWidgets;
	var baseFields = function () {
  	return [
  		{
  			name : "name",
  			isVisible: true,
  			aclIsVisible: true,
  			showOnList: true,
  			skipSearch: false,
  		},
  		{
  			name: "birth",
  			isVisible: true,
  			aclIsVisible: true,
  			showOnList: true,
  			skipSearch: false,
  		}
  	];
	};
	
	
	beforeEach(function () {
		module(function ($provide) {
			//Providing a new $timeout because $timeout.flush is not flushing pending $timeout calls
			$provide.constant("$timeout", setTimeout);
			$provide.constant("$q", Q);
		});
		module("ZeedhiApp");
		module("ZeedhiServices");
		
		inject(function (_$rootScope_, $controller, metaDataFactory) {
			container = baseContainer();
			container.widgets[0].template = "widget/file-upload.html";
			container.widgets[0].fields = baseFields();
			container = metaDataFactory.containerFactory(container);
			widget = container.widgets[0];
			$rootScope = _$rootScope_;
			
			$scope = _$rootScope_.$new();
			$scope.$parent = _$rootScope_;
			$scope.widget = widget;
			$scope.field = widget.fields[0];
			
			fileUploadController = $controller("FileUploadController", {
				$scope: $scope,
				$rootScope: $rootScope
			});
		});
	});
	
	it("deselectFile: should remove the provided file from the widget currentRow", function () {
	  widget.currentRow = {};
	  widget.currentRow[$scope.field.name] = ["firstFile", "secondFile"];
	  $scope.deselectFile("firstFile");
	  expect(widget.currentRow[$scope.field.name]).toEqual(["secondFile"]);
	  expect($scope.field.fileList).toEqual(widget.currentRow[$scope.field.name]);
	});
});