function ProductionLineService(ScreenService, RestEngine, environment, ClientNotificationService, OrderActionService, ApplicationContext, templateManager) {

    var self = this;

    this.closePopup = function(){
        ScreenService.closePopup(); 
        ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
    };


    this.updatePercentage = function(){
        var widget = templateManager.container.getActiveWidget();
        var localEnvironment = environment.getLocalEnvironment();
        var field = widget.getField('linePercentage').value();
        let lineRoute = '/LinePercentage/update';

        if(field){
            var params = {
                requestType: "Row",
                row: {
                    "CDFILIAL": localEnvironment.CDFILIAL,
                    "CDSETOR": localEnvironment.CDSETOR,
                    "PERCENT": field                
                }
            };
    
            RestEngine.post(lineRoute, params).then(function(response) {	
                console.log(response);
            })
            .catch(err =>{
                console.log(err);
            });
    
            self.closePopup(); 
        } else {
			ScreenService.notificationMessage('Digite um percentual válido', 'alert', 5200);
		}

    };

    this.startScanning = function(){
        document.onkeypress = self.keypress.bind(self);
    };

    /* jshint ignore:start */
    this.activateLine = async function(){
        var widget = templateManager.container.getActiveWidget();
        localEnvironment = environment.getLocalEnvironment();
        let CDSETOR = localEnvironment.CDSETOR;
		let checkStatusRoute = '/StatusLineProduction/get';
        var password = widget.getField('linePassword').element.val();
		
        if (password == 5050){
            ScreenService.closePopup(true); 
            var params = {
                requestType: "Row",
                row: {
                        "CDSETOR": CDSETOR
                }
            };
            var lineStatusAction = await RestEngine.post(checkStatusRoute, params).then(function (response) {
				if (response.dataset.checkLineProductionStatus.lineStatus[0]) {
					return response.dataset.checkLineProductionStatus.lineStatus[0].IDATIVO == 'S' ? 'desativar' : 'ativar';
				} else {
					return null; 
				}
            }).catch(err => {
                return err;
            });
    
            if(lineStatusAction){
                ApplicationContext.ShortcutKeyService.bindPopUpKeys();
                ScreenService.confirmMessage('Deseja ' + lineStatusAction + ' esta linha de produção?',
                    'question',
                    function () {
                        let lineProductionRoute = '/StatusLineProduction/update';
        
                        var params = {
                            requestType: "Row",
                            row: {
                                "CDFILIAL": localEnvironment.CDFILIAL,
                                "CDSETOR": localEnvironment.CDSETOR
                            }
                        };
        
                        RestEngine.post(lineProductionRoute, params).then(function (response) {
                            console.log(response.dataset);
                        }).catch(err => {
                            return err;
                        })
                        .finally(() => {
                            window.customKDSReload();
                        });
                    },
                    function () { 
                        setTimeout(() => {
							ApplicationContext.ShortcutKeyService.bindShortcutsOrderPanel();
						}, 300);
                    }
                );
            } else {
                ScreenService.notificationMessage('Não está parametrizada uma linha de produção neste setor', 'alert', 3000);
            }
        } else {
            ScreenService.notificationMessage('Senha incorreta', 'alert', 3000);
        }
    };
    /* jshint ignore:end */

}

Configuration(function (ContextRegister) {
    ContextRegister.register('ProductionLineService', ProductionLineService);
});